#include <sys/socket.h> /* for socket()    */
#include <stdio.h>      /* for perror()    */
#include <string.h>     /* for memset()    */
#include <unistd.h>     /* for sleep()     */

#include "socket.hh"

void Socket::BecomeListenerTCP(int port)
{
	int sock, RetryCount=0;
	
RetrySocket:
	sock = socket(AF_INET, SOCK_STREAM, 0);
	if(sock < 0)
	{
		perror("socket");
		/* FIXME: Now what? */
		sleep(1);
		if(++RetryCount<50)goto RetrySocket;
	}

	struct sockaddr_in mysock;

	memset(&mysock, 0, sizeof(mysock));

	mysock.sin_family = AF_INET;
	mysock.sin_addr.s_addr = htonl(INADDR_ANY);
	/* FIXME: Allow this to be selected^ */
	mysock.sin_port = htons(port);
	
	int dummy = 1;
    setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &dummy, sizeof dummy);
    
RetryBind:
	if(bind(sock, (struct sockaddr *)&mysock, sizeof(mysock)) < 0)
	{
		perror("bind");
		/* FIXME: Now what? */
		sleep(1);
		if(++RetryCount<50)goto RetryBind;
	}
	
	listen(sock, 5);
	
	Type          = Socket::SockTypeListening;
	Protocol      = SockProtocolTCP;
	fd            = sock;
	Peer.DestPort = port;
}

void Socket::BecomeListenerUDP(int port)
{
	int sock, RetryCount=0;
	
RetrySocket:
	sock = socket(AF_INET, SOCK_DGRAM, 0);
	if(sock < 0)
	{
		perror("socket");
		/* FIXME: Now what? */
		sleep(1);
		if(++RetryCount<50)goto RetrySocket;
	}

	struct sockaddr_in mysock;

	memset(&mysock, 0, sizeof(mysock));

	mysock.sin_family = AF_INET;
	mysock.sin_addr.s_addr = htonl(INADDR_ANY);
	/* FIXME: Allow this to be selected^ */
	mysock.sin_port = htons(port);
	
	int dummy = 1;
    setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &dummy, sizeof dummy);
    
RetryBind:
	if(bind(sock, (struct sockaddr *)&mysock, sizeof(mysock)) < 0)
	{
		perror("bind");
		/* FIXME: Now what? */
		sleep(1);
		if(++RetryCount<50)goto RetryBind;
	}
	
	Type          = Socket::SockTypeListening;
	Protocol      = SockProtocolUDP;
	fd            = sock;
	Peer.DestPort = port;
}

void Socket::AcceptTCP(const Socket &parent)
{
	int RetryCount = 0;
	
	Peer = parent.Peer;
	
RetryAccept:
	Peer.AddrLen = sizeof(Peer.Addr);

	int sock = accept(parent.fd, (struct sockaddr *)&Peer.Addr, &Peer.AddrLen);
	if(sock < 0)
	{
		perror("accept");
		/* FIXME: Now what? */
		sleep(1);
		if(++RetryCount<50)goto RetryAccept;
	}
	
	Type     = SockTypeConnected;
	Protocol = SockProtocolTCP;
	fd       = sock;
}

void Socket::ReceiveUDP()
{
    Datatype Buffer[16384];
    
    Peer.AddrLen = sizeof(Peer.Addr);

    int result = recvfrom(fd, Buffer, sizeof(Buffer), 0, (struct sockaddr *)&Peer.Addr, &Peer.AddrLen);
    if(result < 0)
    {
    	perror("recvfrom");
    	/* FIXME: What now? */
    	return;
    }
    
    /* TODO: Record the packet. (Peer.Addr, Peer.AddrLen, Buffer[0..result-1]) */
}

void Socket::ReceiveTCP()
{
    Datatype Buffer[16384];
    
    int result = read(fd, Buffer, sizeof(Buffer));
    if(result < 0)
    {
    	perror("read");
    	/* FIXME: What now? */
    	return;
    }
    if(!result)
    {
    	/* EOF. Ignore it. */
    	return;
    }
    
    /* TODO: Record the packet. (Buffer[0..result-1]) */
}
