#include "protocols.hh"
#include "connection.hh"
#include "buffer.hh"

/* Server socket record */
/* This record contains enough information for
 * the server to know what to do with the fd.
 */
struct Socket
{
    enum SockType
    {
        SockTypeListening,
        SockTypeConnected
    };

    int                fd;
    enum SockProtocol  Protocol;
    enum SockType      Type;
    
    Connection         Peer;
    
    Buffer             SendQueue;
    
    void BecomeListenerTCP(int port);
    void BecomeListenerUDP(int port);
    
    void AcceptTCP(const Socket &parent);
    void ReceiveUDP();
    void ReceiveTCP();
};
